<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCustomerTroubleCondition ArrayType
 * @subpackage Arrays
 */
class ArrayOfCustomerTroubleCondition extends AbstractStructArrayBase
{
    /**
     * The CustomerTroubleCondition
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\CustomerTroubleCondition[]
     */
    public $CustomerTroubleCondition;
    /**
     * Constructor method for ArrayOfCustomerTroubleCondition
     * @uses ArrayOfCustomerTroubleCondition::setCustomerTroubleCondition()
     * @param \CustomerManagement\StructType\CustomerTroubleCondition[] $customerTroubleCondition
     */
    public function __construct(array $customerTroubleCondition = array())
    {
        $this
            ->setCustomerTroubleCondition($customerTroubleCondition);
    }
    /**
     * Get CustomerTroubleCondition value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\CustomerTroubleCondition[]|null
     */
    public function getCustomerTroubleCondition()
    {
        return isset($this->CustomerTroubleCondition) ? $this->CustomerTroubleCondition : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomerTroubleCondition method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomerTroubleCondition method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomerTroubleConditionForArrayConstraintsFromSetCustomerTroubleCondition(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCustomerTroubleConditionCustomerTroubleConditionItem) {
            // validation for constraint: itemType
            if (!$arrayOfCustomerTroubleConditionCustomerTroubleConditionItem instanceof \CustomerManagement\StructType\CustomerTroubleCondition) {
                $invalidValues[] = is_object($arrayOfCustomerTroubleConditionCustomerTroubleConditionItem) ? get_class($arrayOfCustomerTroubleConditionCustomerTroubleConditionItem) : sprintf('%s(%s)', gettype($arrayOfCustomerTroubleConditionCustomerTroubleConditionItem), var_export($arrayOfCustomerTroubleConditionCustomerTroubleConditionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CustomerTroubleCondition property can only contain items of type \CustomerManagement\StructType\CustomerTroubleCondition, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CustomerTroubleCondition value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\CustomerTroubleCondition[] $customerTroubleCondition
     * @return \CustomerManagement\ArrayType\ArrayOfCustomerTroubleCondition
     */
    public function setCustomerTroubleCondition(array $customerTroubleCondition = array())
    {
        // validation for constraint: array
        if ('' !== ($customerTroubleConditionArrayErrorMessage = self::validateCustomerTroubleConditionForArrayConstraintsFromSetCustomerTroubleCondition($customerTroubleCondition))) {
            throw new \InvalidArgumentException($customerTroubleConditionArrayErrorMessage, __LINE__);
        }
        if (is_null($customerTroubleCondition) || (is_array($customerTroubleCondition) && empty($customerTroubleCondition))) {
            unset($this->CustomerTroubleCondition);
        } else {
            $this->CustomerTroubleCondition = $customerTroubleCondition;
        }
        return $this;
    }
    /**
     * Add item to CustomerTroubleCondition value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\CustomerTroubleCondition $item
     * @return \CustomerManagement\ArrayType\ArrayOfCustomerTroubleCondition
     */
    public function addToCustomerTroubleCondition(\CustomerManagement\StructType\CustomerTroubleCondition $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\CustomerTroubleCondition) {
            throw new \InvalidArgumentException(sprintf('The CustomerTroubleCondition property can only contain items of type \CustomerManagement\StructType\CustomerTroubleCondition, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CustomerTroubleCondition[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\CustomerTroubleCondition|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\CustomerTroubleCondition|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\CustomerTroubleCondition|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\CustomerTroubleCondition|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\CustomerTroubleCondition|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CustomerTroubleCondition
     */
    public function getAttributeName()
    {
        return 'CustomerTroubleCondition';
    }
}
